## csound 6.02~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project (Csound)

ENABLE_TESTING()

message(STATUS "${CMAKE_HOME_DIRECTORY}")

set(CMAKE_CXX_FLAGS_RELEASE "-O3 ")
set(CMAKE_C_FLAGS_RELEASE "-O3 ")

# Project definitions
set(APIVERSION "6.0")

# Relative install paths
set(EXECUTABLE_INSTALL_DIR "bin")

option(USE_LIB64 "Set to on to set installation directory for libraries to lib64" OFF)
if(USE_LIB64)
    set(LIBRARY_INSTALL_DIR "lib64")
else()
    set(LIBRARY_INSTALL_DIR "lib")
endif()
message(STATUS "LIBRARY INSTALL DIR: ${LIBRARY_INSTALL_DIR}")

if(USE_DOUBLE)
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins64-${APIVERSION}")
else()
    set(PLUGIN_INSTALL_DIR "${LIBRARY_INSTALL_DIR}/csound/plugins-${APIVERSION}")
endif()
set(PYTHON_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})
set(JAVA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})
set(LUA_MODULE_INSTALL_DIR ${LIBRARY_INSTALL_DIR})
set(LOCALE_INSTALL_DIR "share/locale")
set(HEADER_INSTALL_DIR "include/csound")

set(CS_FRAMEWORK_DEST "~/Library/Frameworks")
include(TestBigEndian)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CMakeParseArguments)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Utility function to make executables. All plugin targets should use this as it
# sets up output directory set in top-level CmakeLists.txt
# and adds an appropriate install target
#
# name - name of executable to produce
# srcs - list of src files
# libs - list of library files to link to
# output_name (OPTIONAL) - overide the name of the generated executable
#
function(make_executable name srcs libs)
    add_executable(${name} ${srcs})
    target_link_libraries (${name} ${libs})
    set_target_properties(${name} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR})

    if(${ARGC} EQUAL 4)
        set_target_properties(${name} PROPERTIES
            OUTPUT_NAME ${ARGV3})
    endif()
    install(TARGETS ${name}
	RUNTIME DESTINATION "${EXECUTABLE_INSTALL_DIR}" )
endfunction(make_executable)


# Utility function to make a utility executable
#
# name - name of executable to produce
# srcs - list of src files

function(make_utility name srcs)
    make_executable(${name} "${srcs}" "${CSOUNDLIB}")
    add_dependencies(${name} ${CSOUNDLIB})
endfunction()


# Expands a list into a space-separated string (outvar element1 ....)
# Why do I have to do this? Cmake, you just lost one point
function(expand_list out)
    set(i 1)
    set(tmp "")
    while( ${i} LESS ${ARGC} )
        set(tmp "${tmp} ${ARGV${i}}")
        math(EXPR i "${i}+1")
    endwhile()
    set(${out} "${tmp}" PARENT_SCOPE)
endfunction(expand_list)

# Checks if dependencies for an enabled target are fulfilled.
# If FAIL_MISSING is true and the dependencies are not fulfilled,
# it will abort the cmake run.
# If FAIL_MISSING is false, it will set the option to OFF.
# If the target is not enabled, it will do nothing.
# example: check_deps(BUILD_NEW_PARSER FLEX_EXECUTABLE BISON_EXECUTABLE)
function(check_deps option)
    if(${option})
        set(i 1)
        while( ${i} LESS ${ARGC} )
            set(dep ${ARGV${i}})
            if(NOT ${dep})
                if(FAIL_MISSING)
                    message(FATAL_ERROR
                        "${option} is enabled, but ${dep}=\"${${dep}}\"")
                else()
                    message(STATUS "${dep}=\"${${dep}}\", so disabling ${option}")
                    set(${option} OFF PARENT_SCOPE)
                    # Set it in the local scope too
                    set(${option} OFF)
                endif()
            endif()
            math(EXPR i "${i}+1")
        endwhile()
    endif()
    if(${option})
        message(STATUS "${option} is enabled")
    else()
        message(STATUS "${option} is disabled")
    endif()
endfunction(check_deps)

# Shortcut to add compiler flags
# Mandatory arguments: the flags to add, should be passed before optional keywords, can be
#                      passed as lists or space-separated
# Optional keywords:
# LINKER: add to linker instead of compile flags (LDFLAGS vs CFLAGS)
# TARGETS <target1> <target2> ...
#           if specified, will add the flags to a target instead
#           of the global namespace
function(add_compiler_flags)
    set(bool_options LINKER)
    set(multi_val_args TARGETS)
    cmake_parse_arguments(FLAGS "${bool_options}" "" "${multi_val_args}" ${ARGN})

    expand_list(FLAGS ${FLAGS_UNPARSED_ARGUMENTS})

    if(FLAGS_TARGETS)
        foreach(target ${FLAGS_TARGETS})
            if(NOT FLAGS_LINKER)
                set(property "COMPILE_FLAGS")
            else()
                set(property "LINK_FLAGS")
            endif()
            get_target_property(propval ${target} ${property})
            if(NOT propval)
                set(propval "")
            endif()
            set_target_properties(${target} PROPERTIES
                ${property} "${propval} ${FLAGS}")
        endforeach()
    else()
        if(FLAGS_LINKER)
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${FLAGS}")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${FLAGS}")
            set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${FLAGS}")
        else()
            add_definitions("${FLAGS}")
        endif()
    endif()
endfunction(add_compiler_flags)

### COMPILER OPTIMIZATION FLAGS
option(USE_COMPILER_OPTIMIZATIONS "Use the default Csound compiler optimization flags" ON)
if(USE_COMPILER_OPTIMIZATIONS)
include(cmake/CompilerOptimizations.cmake)
endif()

# Include this after the install path definitions so we can override them here.
# Also after function definitions so we can use them there
find_file(CUSTOM_CMAKE "Custom.cmake" HINTS ${CMAKE_HOME_DIRECTORY})
if(CUSTOM_CMAKE)
    message(STATUS "Including Custom.cmake file: ${CUSTOM_CMAKE}")
    include(${CUSTOM_CMAKE})
else()
    message(STATUS "Not using Custom.cmake file.")
endif()


if(WIN32 AND NOT MSVC)
    if(EXISTS "C:/MinGW/include")
        include_directories(C:/MinGW/include)
    else()
        MESSAGE(STATUS "MinGW include dir not found")
    endif()

    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--add-stdcall-alias")
endif()

if(WIN32)
    set(CMAKE_SHARED_LIBRARY_PREFIX "")
    set(CMAKE_SHARED_MODULE_PREFIX "")

    set(CSOUND_WINDOWS_LIBRARIES
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        msvcrt
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32
        advapi32
        comctl32
        comdlg32
        glu32
        kernel32
        odbc32
        odbccp32
        ole32
        oleaut32
        shell32
        user32
        uuid
        winmm
        winspool
        ws2_32
        wsock32)

endif(WIN32)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(LINUX YES)
else()
    set(LINUX NO)
endif()

## USER OPTIONS ##

option(USE_DOUBLE "Set to use double-precision floating point for audio samples." ON)
option(BUILD_UTILITIES "Build stand-alone executables for utilities that can also be used with -U" ON)

option(NEW_PARSER_DEBUG "Enable tracing of new parser" OFF)

option(SCORE_PARSER "Enable building of alternative score parser" OFF)

option(BUILD_MULTI_CORE "Enable building for multicore system (requires BUILD_NEW_PARSER)" ON)

option(FAIL_MISSING "Fail when a required external dependency is not present (useful for packagers)" OFF)

option(USE_GETTEXT "Use the Gettext internationalization library" ON)

option(BUILD_STATIC_LIBRARY "Also build a static version of the csound library" OFF)

option(USE_OPEN_MP "Use OpenMP for Parallel Performance" ON)
option(USE_LRINT "Use lrint/lrintf for converting floating point values to integers." ON)
option(USE_CURL "Use CURL library" ON)
option(BUILD_RELEASE "Build for release" ON)
option(BUILD_INSTALLER "Build for release" OFF)
option(BUILD_TESTS "Build for release" ON)
# Optional targets, they should all default to ON (check_deps will disable them if not possible to build)


set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

# This needs to be here since _everybody_ needs this flag
if(USE_DOUBLE)
    add_definitions("-DUSE_DOUBLE")
endif(USE_DOUBLE)
check_c_compiler_flag(-fvisibility=hidden HAS_VISIBILITY_HIDDEN)
check_cxx_compiler_flag(-fvisibility=hidden HAS_CXX_VISIBILITY_HIDDEN)
if (HAS_VISIBILITY_HIDDEN)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()
if (HAS_CXX_VISBILITY_HIDDEN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif()

if(APPLE)
  if(BUILD_INSTALLER)
    set(CS_FRAMEWORK_DEST "${CMAKE_INSTALL_PREFIX}")
  endif()

  set(DEFAULT_OSX_SYSROOT /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.8.sdk/)

  if(NOT CMAKE_OSX_SYSROOT AND EXISTS ${DEFAULT_OSX_SYSROOT})
    set(CMAKE_OSX_SYSROOT ${DEFAULT_OSX_SYSROOT})
  endif()

  if(EXISTS ${CMAKE_OSX_SYSROOT})
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.6)
  endif()

endif()

if(USE_DOUBLE)
    if(APPLE)
        set(CSOUNDLIB "CsoundLib64")
        set(PLUGIN_INSTALL_DIR "${CS_FRAMEWORK_DEST}/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes64")
    else()
        set(CSOUNDLIB "csound64")
    endif()
else()
    if(APPLE)
        set(CSOUNDLIB "CsoundLib")
        set(PLUGIN_INSTALL_DIR "${CS_FRAMEWORK_DEST}/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes")
    else()
        set(CSOUNDLIB "csound")
    endif()
endif()

if(APPLE)
    if(BUILD_INSTALLER)
	set(CS_FRAMEWORK_FULL_PATH "/Library/Frameworks/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes64")
    else()
        get_filename_component(PYTHON_MODULE_INSTALL_DIR "~/Library/Python/2.7/lib/python/site-packages" ABSOLUTE)
        get_filename_component(JAVA_MODULE_INSTALL_DIR "~/Library/Java/Extensions" ABSOLUTE)
        get_filename_component(CS_FRAMEWORK_FULL_PATH ${PLUGIN_INSTALL_DIR} ABSOLUTE)
    endif()

    add_definitions("-DCS_DEFAULT_PLUGINDIR=\"${CS_FRAMEWORK_FULL_PATH}\"")

endif()

if(BUILD_RELEASE)
    add_definitions("-D_CSOUND_RELEASE_")
    if(LINUX)
        set(DEFAULT_OPCODEDIR "${CMAKE_INSTALL_PREFIX}/${PLUGIN_INSTALL_DIR}")
        add_definitions("-DCS_DEFAULT_PLUGINDIR=\"${DEFAULT_OPCODEDIR}\"")
    endif()
else()
    add_definitions("-DBETA")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    add_definitions("-Wno-format")
    #    add_compiler_flags("-g")
endif()


#if(USE_DOUBLE)
#    set(BUILD_PLUGINS_DIR ${BUILD_DIR}/plugins64)
#else()
#    set(BUILD_PLUGINS_DIR ${BUILD_DIR}/plugins)
#endif()

set(BUILD_PLUGINS_DIR ${BUILD_DIR})
set(BUILD_BIN_DIR ${BUILD_DIR})
set(BUILD_LIB_DIR ${BUILD_DIR})

#if(APPLE AND NOT ${CMAKE_GENERATOR} STREQUAL "Xcode")
#    set(BUILD_PLUGINS_DIR ${BUILD_DIR}/${CSOUNDLIB}.framework/Versions/${APIVERSION}/Resources/Opcodes)
#endif()

message(STATUS "BUILD_BIN_DIR set to ${BUILD_BIN_DIR}")
message(STATUS "BUILD_LIB_DIR set to ${BUILD_LIB_DIR}")
message(STATUS "BUILD_PLUGINS_DIR set to ${BUILD_PLUGINS_DIR}")

# OS specific checks

TEST_BIG_ENDIAN(BIG_ENDIAN)

## CONFIGURATION ##

SET(BUILD_SHARED_LIBS ON)

## HEADER/LIBRARY/OTHER CHECKS ##
find_package(OpenMP)

# First, required stuff
find_library(LIBSNDFILE_LIBRARY sndfile)

if(NOT LIBSNDFILE_LIBRARY AND WIN32)
find_library(LIBSNDFILE_LIBRARY sndfile-1)
endif()

if(NOT LIBSNDFILE_LIBRARY)
    message(FATAL_ERROR "Csound requires the sndfile library")
endif()

find_path(SNDFILE_H_PATH sndfile.h)
if(SNDFILE_H_PATH)
    include_directories(${SNDFILE_H_PATH})
else()
    message(FATAL_ERROR "Could not find sndfile.h")
endif()

find_library(PTHREAD_LIBRARY pthread)

if(NOT PTHREAD_LIBRARY AND WIN32)
    find_library(PTHREAD_LIBRARY pthreadGC2)
endif()

if(NOT PTHREAD_LIBRARY)
    message(FATAL_ERROR "Csound requires the pthread library")

=== InOut/CMakeLists.txt ===
# REAL TIME AUDIO AND MIDI

message(STATUS "")
message(STATUS "## REALTIME AUDIO AND MIDI ##")

option(USE_PULSEAUDIO "Build the PulseAudio I/O module" ON)
option(USE_PORTAUDIO "Build the PortAudio I/O module" ON)
option(USE_PORTMIDI "Build the PortMIDI I/O module" ON)
option(USE_IPMIDI "Build the IPMIDI I/O module" ON)
option(USE_JACK "Build the jack I/O module and opcodes" ON)
option(USE_ALSA "Build the ALSA I/O module" ON)
# option(USE_COREAUDIO "Build the CoreAudio I/O module" ON)
option(USE_COREMIDI "Build the CoreMIDI I/O Module" ON)
option(USE_AUDIOUNIT "Build teh CoreAudio AudioUnit I/O module (requires CoreAudio)" ON)
option(USE_FLTK "Use FLTK for graphs and widget opcodes" ON)
option(BUILD_VIRTUAL_KEYBOARD "Build Virtual MIDI keyboard" ON)


set(CMAKE_REQUIRED_INCLUDES /usr/local/include)

# FIND LIBRARIES AND HEADERS

if(USE_ALSA)
    find_library(ALSA_LIBRARY asound)
    check_include_file(alsa/asoundlib.h ALSA_HEADER)
endif()
if(USE_PORTAUDIO)
    find_path(PORTAUDIO_INCLUDE_PATH portaudio.h)
    find_library(PORTAUDIO_LIBRARY portaudio)
endif()
if(USE_PORTMIDI)
    find_path(PORTMIDI_INCLUDE_PATH portmidi.h)
    find_library(PORTMIDI_LIBRARY portmidi)
#    include_directories(${PORTMIDI_INCLUDE_PATH})
#    include_directories(${PORTTIME_INCLUDE_PATH})
    if(WIN32)
    else()
        find_library(PORTTIME_LIBRARY porttime)
    endif()
endif()
if(USE_JACK)
    find_library(JACK_LIBRARY jack)
    find_library(JACKDMP_LIBRARY jackdmp)
    check_include_file(jack/jack.h JACK_HEADER)
endif()
if(USE_PULSEAUDIO)
    find_library(PULSEAUDIO_LIBRARY pulse)
    find_library(PULSESIMPLE_LIBRARY pulse-simple)
    check_include_file(pulse/simple.h PULSEAUDIO_HEADER)
endif()
# if(USE_COREAUDIO)
#    find_path(COREAUDIO_INCLUDE_PATH CoreAudio.h)
#    find_library(COREAUDIO_LIBRARY CoreAudio)
# endif()
if(USE_COREMIDI)
    find_path(COREMIDI_INCLUDE_PATH CoreMidi.h)
    find_library(COREMIDI_LIBRARY CoreMidi)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
endif()
if(USE_AUDIOUNIT)
    find_path(AUDIOUNIT_INCLUDE_PATH AudioUnit.h)
    find_library(AUDIOUNIT_LIBRARY AudioUnit)
    find_library(COREFOUNDATION_LIBRARY CoreFoundation)
    find_path(COREAUDIO_INCLUDE_PATH CoreAudio.h)
    find_library(COREAUDIO_LIBRARY CoreAudio)
endif()

# BUILD TARGETS

# check_deps(USE_COREAUDIO APPLE COREAUDIO_INCLUDE_PATH COREAUDIO_LIBRARY)
# if(USE_COREAUDIO)
#    make_plugin(rtcoreaudio rtcoreaudio.c)
#    include_directories(${COREAUDIO_INCLUDE_PATH})
#    target_link_libraries(rtcoreaudio ${COREAUDIO_LIBRARY})
# endif()

check_deps(USE_COREMIDI APPLE COREMIDI_INCLUDE_PATH COREMIDI_LIBRARY COREFOUNDATION_LIBRARY)
if(USE_COREMIDI)
    make_plugin(cmidi cmidi.c)
    include_directories(${COREMIDI_INCLUDE_PATH})
    target_link_libraries(cmidi ${COREMIDI_LIBRARY} ${COREFOUNDATION_LIBRARY})
endif()

check_deps(USE_AUDIOUNIT APPLE COREAUDIO_INCLUDE_PATH COREAUDIO_LIBRARY AUDIOUNIT_INCLUDE_PATH AUDIOUNIT_LIBRARY COREFOUNDATION_LIBRARY)
if(USE_AUDIOUNIT)
    make_plugin(rtauhal rtauhal.c)
    include_directories(${AUDIOUNIT_INCLUDE_PATH})
    target_link_libraries(rtauhal ${AUDIOUNIT_LIBRARY} ${COREFOUNDATION_LIBRARY} ${COREAUDIO_LIBRARY})
endif()

check_deps(USE_ALSA ALSA_HEADER ALSA_LIBRARY PTHREAD_LIBRARY)
if(USE_ALSA)
    set(rtalsa_LIBS
        ${ALSA_LIBRARY} ${PTHREAD_LIBRARY} m)
    make_plugin(rtalsa rtalsa.c ${rtalsa_LIBS})
endif()

if(WIN32)
    message(STATUS "Building Windows MME plugin(rtwinmm).")
    set(rtwinmm_LIBS
        winmm gdi32 kernel32) # should probably do checks for these libs
    make_plugin(rtwinmm rtwinmm.c "${rtwinmm_LIBS}")
endif()


check_deps(USE_PULSEAUDIO PULSEAUDIO_HEADER PULSEAUDIO_LIBRARY PULSESIMPLE_LIBRARY)
if(USE_PULSEAUDIO)
    make_plugin(rtpulse rtpulse.c ${PULSEAUDIO_LIBRARY} ${PULSESIMPLE_LIBRARY})
endif()

check_deps(USE_PORTAUDIO PORTAUDIO_INCLUDE_PATH PORTAUDIO_LIBRARY)
if(USE_PORTAUDIO)
    set(rtpa_LIBS ${PORTAUDIO_LIBRARY})
    include_directories(${PORTAUDIO_INCLUDE_PATH})

    if(WIN32)
        list(APPEND rtpa_LIBS winmm dsound ${CSOUND_WINDOWS_LIBRARIES})
    endif()

    make_plugin(rtpa rtpa.c ${rtpa_LIBS})
    add_dependency_to_framework(portaudio ${PORTAUDIO_LIBRARY})
endif()

if(APPLE)
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY)
elseif(WIN32)
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTTIME_INCLUDE_PATH PORTMIDI_LIBRARY)
else()
    check_deps(USE_PORTMIDI PORTMIDI_INCLUDE_PATH PORTMIDI_LIBRARY PORTTIME_LIBRARY)
endif()

if(USE_PORTMIDI)
    set(pmidi_LIBS ${PORTMIDI_LIBRARY})
    include_directories(${PORTMIDI_INCLUDE_PATH})
    if(LINUX)
        list(APPEND pmidi_LIBS ${PORTTIME_LIBRARY})
    endif()
    if(WIN32)
        include_directories(${PORTTIME_INCLUDE_PATH})
        list(APPEND pmidi_LIBS ${CSOUND_WINDOWS_LIBRARIES})
    endif()
    if(LINUX AND ALSA_LIBRARY)
        list(APPEND pmidi_LIBS ${ALSA_LIBRARY})
    endif()
    make_plugin(pmidi pmidi.c "${pmidi_LIBS}")
    add_dependency_to_framework(pmidi ${PORTMIDI_LIBRARY})
endif()

#check_deps(USE_IPMIDI PORTMIDI_HEADER PORTMIDI_LIBRARY)
if(USE_IPMIDI)
    if(WIN32)
      set(ipmidi_LIBS ws2_32)
    endif()
    make_plugin(ipmidi ipmidi.c "${ipmidi_LIBS}")
endif()

check_deps(USE_JACK JACK_HEADER JACK_LIBRARY)
if(USE_JACK)
    set(rtjack_LIBS "")
    if(LINUX)
        list(APPEND rtjack_LIBS
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    elseif(WIN32)
        list(APPEND rtjack_LIBS
            ${JACKDMP_LIBRARY} ${PTHREAD_LIBRARY})
    else()
        list(APPEND rtjack_LIBS
            ${JACK_LIBRARY} ${PTHREAD_LIBRARY})
    endif()
    make_plugin(rtjack rtjack.c "${rtjack_LIBS}")
endif()

check_deps(USE_FLTK FLTK_FOUND)
if(USE_FLTK)
    set(widgets_SRCS FL_graph.cpp winFLTK.c widgets.cpp)
    make_plugin(widgets "${widgets_SRCS}" "${FLTK_LIBRARIES}")
    #add_dependency_to_framework(widgets ${FLTK_BASE_LIBRARY})
    #add_dependency_to_framework(widgets ${FLTK_FORMS_LIBRARY})
    #add_dependency_to_framework(widgets ${FLTK_IMAGES_LIBRARY})
endif()

check_deps(BUILD_VIRTUAL_KEYBOARD FLTK_FOUND)
if(BUILD_VIRTUAL_KEYBOARD)
    set(virtual_SRCS virtual_keyboard/FLTKKeyboard.cpp
        virtual_keyboard/FLTKKeyboardWindow.cpp
        virtual_keyboard/FLTKKeyboardWidget.cpp
        virtual_keyboard/virtual_keyboard.cpp
        virtual_keyboard/Bank.cpp
        virtual_keyboard/KeyboardMapping.cpp
        virtual_keyboard/Program.cpp
        virtual_keyboard/SliderBank.cpp
        virtual_keyboard/SliderData.cpp)
    make_plugin(virtual "${virtual_SRCS}" "${FLTK_LIBRARIES}")
    #add_dependency_to_framework(virtual ${FLTK_BASE_LIBRARY})
    #add_dependency_to_framework(virtual ${FLTK_FORMS_LIBRARY})
    #add_dependency_to_framework(virtual ${FLTK_IMAGES_LIBRARY})
    include_directories(".")
    include_directories(${FLTK_INCLUDE_DIR})
endif()

message(STATUS "")

=== Opcodes/CMakeLists.txt ===
option(BUILD_CHUA_OPCODES "Build the chua opcodes (requires boost)" ON)
option(BUILD_DSSI_OPCODES "Build the DSSI opcodes" ON)
option(BUILD_FLUID_OPCODES "Build the fluidsynth opcodes" ON)
option(BUILD_JACK_OPCODES "Build the JACK related opcodes" ON)
option(BUILD_LINEAR_ALGEBRA_OPCODES "Build the Linear Algebra Opcodes" ON)
option(BUILD_OSC_OPCODES "Build the OSC Opcodes" ON)
option(BUILD_IMAGE_OPCODES "Build the image opcodes" ON)
option(BUILD_PYTHON_OPCODES "Build the Python opcodes" ON)
option(BUILD_LUA_OPCODES "Build the Lua opcodes" ON)
option(BUILD_WIIMOTE_OPCODES "Build the Wiimote opcodes" ON)
option(BUILD_P5GLOVE_OPCODES "Build the P5Glove opcodes" ON)
option(BUILD_SERIAL_OPCODES "Build the serial opcode" ON)
option(BUILD_PLATEREV_OPCODES "Build the platerev opcode" ON)
option(BUILD_FAUST_OPCODES "Build the Faust opcodes" OFF)
option(BUILD_VST4CS_OPCODES "Build the vst4cs opcodes" OFF)

find_package(Boost)
check_include_file(ladspa.h LADSPA_H)
check_include_file(fluidsynth.h FLUIDSYNTH_H)
find_library(FLUIDSYNTH_LIBRARY fluidsynth)
find_library(JACK_LIBRARY jack)
find_library(JACKDMP_LIBRARY jackdmp)
check_include_file(jack/jack.h JACK_HEADER)
check_include_file_cxx(gmm/gmm.h GMM_HEADER)
check_include_file_cxx(eigen3/E.h GMM_HEADER)
#check_include_file(lo/lo.h OSC_HEADER)
find_library(LIBLO_LIBRARY lo)
find_package(PNG)
set(PYTHON_INCLUDE_DIRS /usr/include/Python2.7)
set(Python_ADDITIONAL_VERSIONS 2.7)
find_package(PythonLibs)

find_library(LUAJIT_LIBRARY luajit)
if(NOT LUAJIT_LIBRARY)
    find_library(LUAJIT_LIBRARY luajit-5.1)
endif()
find_path(LUA_H_PATH luajit-2.0/lua.h)

check_include_file(wiiuse.h WIIUSE_H)
find_library(WIIUSE_LIB wiiuse)
check_include_file(p5glove.h P5GLOVE_H)
find_library(P5GLOVE_LIB p5glove)

if(BUILD_FAUST_OPCODES)
find_package(LLVM)
exec_program(llvm-config ARGS --libs OUTPUT_VARIABLE LLVM_LIBS)
find_library(FAUST_LIBRARY faust HINTS /usr/local/lib/faust)
endif()

## OPCODE LIBS WITH NO EXTERNAL DEPENDENCIES ##

make_plugin(mixer mixer.cpp)
make_plugin(signalflowgraph signalflowgraph.cpp)

make_plugin(ampmidid ampmidid.cpp)
make_plugin(cs_date date.c)
make_plugin(system_call system_call.c)
make_plugin(doppler doppler.cpp)
make_plugin(fractalnoise tl/fractalnoise.cpp)

make_plugin(fareygen fareygen.c)

make_plugin(cellular cellular.c)

if(BUILD_SERIAL_OPCODES)
   make_plugin(serial serial.c)
endif()

if(BUILD_PLATEREV_OPCODES)
   make_plugin(platerev platerev.c m)
endif()

set(scansyn_SRCS
    scansyn.c scansynx.c)
make_plugin(scansyn "${scansyn_SRCS}" m)

if(UNIX)
    make_plugin(control control.c)
endif()

if(LINUX)
    make_plugin(urandom urandom.c)
    make_plugin(joystick linuxjoystick.c)
endif()

## OPCODES WITH EXTERNAL DEPENDENCIES ##

check_deps(BUILD_CHUA_OPCODES Boost_FOUND)
if(BUILD_CHUA_OPCODES)
    include_directories(${Boost_INCLUDE_DIRS})
    make_plugin(chua chua/ChuaOscillator.cpp)
endif()

check_deps(BUILD_DSSI_OPCODES LADSPA_H)
if(BUILD_DSSI_OPCODES)
    set(dssi_SRC dssi4cs/src/load.c dssi4cs/src/dssi4cs.c)
    make_plugin(dssi4cs "${dssi_SRC}" dl)
endif()

check_deps(BUILD_FLUID_OPCODES FLUIDSYNTH_H FLUIDSYNTH_LIBRARY)
if(BUILD_FLUID_OPCODES)
    if(EXISTS ${FLUIDSYNTH_INCLUDE_DIR})
        include_directories("${FLUIDSYNTH_INCLUDE_DIR}")
     endif()
    make_plugin(fluidOpcodes fluidOpcodes/fluidOpcodes.cpp ${FLUIDSYNTH_LIBRARY})
    add_dependency_to_framework(fluidOpcodes ${FLUIDSYNTH_LIBRARY})
endif()

set(JACK_LIB (JACK_LIBRARY OR JACKDMP_LIBRARY))
check_deps(BUILD_JACK_OPCODES JACK_HEADER JACK_LIB)
if(BUILD_JACK_OPCODES)
    set(jack_LIBS ${PTHREAD_LIBRARY})
    if(JACKDMP_LIBRARY)
        list(APPEND jack_LIBS ${JACKDMP_LIBRARY})
    else()
        list(APPEND jack_LIBS ${JACK_LIBRARY})
    endif()
    make_plugin(jacko jacko.cpp "${jack_LIBS}")
    make_plugin(jackTransport jackTransport.c "${jack_LIBS}")
endif()

check_deps(BUILD_LINEAR_ALGEBRA_OPCODES GMM_HEADER)
if(BUILD_LINEAR_ALGEBRA_OPCODES)
    make_plugin(linear_algebra linear_algebra.cpp)
endif()

check_deps(BUILD_OSC_OPCODES LIBLO_LIBRARY)
if(BUILD_OSC_OPCODES)
    make_plugin(osc OSC.c)
    if(WIN32)
      target_link_libraries(osc ${LIBLO_LIBRARY} pthread wsock32 ws2_32)
    else()
      target_link_libraries(osc ${LIBLO_LIBRARY} pthread)
    endif()
    add_dependency_to_framework(osc ${LIBLO_LIBRARY})
endif()

check_deps(BUILD_IMAGE_OPCODES PNG_FOUND)
if(BUILD_IMAGE_OPCODES)
    include_directories(${PNG_INCLUDE_DIR})
    make_plugin(image imageOpcodes.c "${PNG_LIBRARIES}")
    add_compiler_flags(${PNG_DEFINITIONS} TARGETS image)
    add_dependency_to_framework(image ${PNG_LIBRARY})
endif()

check_deps(BUILD_PYTHON_OPCODES PYTHONLIBS_FOUND)
if(BUILD_PYTHON_OPCODES)
    include_directories(${PYTHON_INCLUDE_DIRS})
    make_plugin(py py/pythonopcodes.c ${PYTHON_LIBRARIES})
endif()

if(NOT APPLE)
  check_deps(BUILD_LUA_OPCODES LUAJIT_LIBRARY LUA_H_PATH)
  if(BUILD_LUA_OPCODES)
    make_plugin(LuaCsound LuaCsound.cpp ${LUAJIT_LIBRARY})
    add_compiler_flags(${OpenMP_CXX_FLAGS} TARGETS LuaCsound)
    add_compiler_flags(${OpenMP_CXX_FLAGS} TARGETS LuaCsound LINKER)
    include_directories(${LUA_H_PATH}/luajit-2.0)
  endif()
endif()

check_deps(BUILD_WIIMOTE_OPCODES WIIUSE_H)
if(BUILD_WIIMOTE_OPCODES)
    make_plugin(wiimote wiimote.c ${WIIUSE_LIB})
    add_dependency_to_framework(wiimote ${WIIUSE_LIB})

endif()

check_deps(BUILD_P5GLOVE_OPCODES P5GLOVE_H)
if(BUILD_P5GLOVE_OPCODES)
    make_plugin(p5g p5glove.c ${P5GLOVE_LIB})
endif()

check_deps(BUILD_FAUST_OPCODES LLVM_FOUND FAUST_LIBRARY)
if(BUILD_FAUST_OPCODES)
  make_plugin(faustcsound faustgen.cpp)
  add_compiler_flags("-DFAUSTFLOAT=double"  TARGETS faustcsound)
  target_link_libraries(faustcsound ${FAUST_LIBRARY} -L/usr/local/lib ${LLVM_LIBS})
  include_directories(${LLVM_INCLUDE_DIRS})
endif()


# OGG Opcode previously was built only for OLPC
#if(VORBISFILE_LIBRARY)
#    set(vorbis_LIBS ${libcsound_LIBS} ${VORBISFILE_LIBRARY})
#    make_plugin(ogg ogg.c "${vorbis_LIBS}")
#endif()

check_deps(BUILD_VST4CS_OPCODES VSTSDK2X_DIR FLTK_FOUND)
if(BUILD_VST4CS_OPCODES)
    include_directories(${CMAKE_HOME_DIRECTORY}/interfaces)
    include_directories(${VSTSDK2X_DIR})
    include_directories(${VSTSDK2X_DIR}/public.sdk/source/vst2.x)
    include_directories(${VSTSDK2X_DIR}/pluginterfaces/source/vst2.x)
    include_directories(${FLTK_INCLUDE_DIR})
    add_definitions(-DVST_FORCE_DEPRECATED=0 -DCS_VSTHOST)
    set(VST4CS_SRCS
        vst4cs/src/vst4cs.cpp
        vst4cs/src/vsthost.cpp
        vst4cs/src/fxbank.cpp
        ${VSTSDK2X_DIR}/public.sdk/source/vst2.x/audioeffect.cpp
        ${VSTSDK2X_DIR}/public.sdk/source/vst2.x/audioeffectx.cpp)
    add_library(vst4cs SHARED ${VST4CS_SRCS})
    set_target_properties(vst4cs PROPERTIES
        LINK_INTERFACE_LIBRARIES ""
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        )
    target_link_libraries(vst4cs ${CSOUNDLIB} ${FLTK_LIBRARIES})
    install(TARGETS vst4cs
        LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR}
        ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR})
endif()


#set(sfont_FLAGS "")

#if(CMAKE_C_COMPILER MATCHES "gcc")
#    set(sfont_FLAGS ${sfont_FLAGS} -fno-strict-aliasing)
#endif()
#if(BIG_ENDIAN)
#    set(sfont_FLAGS ${sfont_FLAGS} -DWORDS_BIGENDIAN)
#endif()
#message(STATUS "Compiler flags used for sfont lib: ${sfont_FLAGS}")
#make_plugin(sfont sfont.c m)
#set_target_properties(sfont
#    PROPERTIES COMPILER_FLAGS "${sfont_FLAGS}")

add_subdirectory(stk)

=== frontends/CMakeLists.txt ===
option(BUILD_PD_CLASS "Build the puredata csoundapi~ class" ON)
option(BUILD_CSBEATS "Build the beats score frontend" ON)
option(BUILD_WINSOUND "Build the Winsound frontend. Requires FLTK headers and libs." OFF)
option(BUILD_CSOUND_VST "Build the CsoundVST frontend. Requires the Steinberg VST SDK 2.3." OFF)

find_package(FLEX)
find_package(BISON)

find_path(PD_HEADER_PATH m_pd.h)
find_library(PD_LIBRARY pd.dll)

## Csound Commandline Executable ##
set(CS_MAIN_SRCS csound/csound_main.c)
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    list(APPEND CS_MAIN_SRCS csound/sched.c)
    list(APPEND CSOUNDLIB -lpthread)
endif()

function(make_plugin_frontend libname srcs)
    if(APPLE)
        add_library(${libname} SHARED ${srcs})
    else()
        add_library(${libname} MODULE ${srcs})
    endif()

    set(i 2)
    while( ${i} LESS ${ARGC} )
        if(NOT MSVC OR NOT("${ARGV${i}}" MATCHES "m"))
            target_link_libraries(${libname} ${ARGV${i}})
        endif()
        math(EXPR i "${i}+1")
    endwhile()

    set_target_properties(${libname} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})

    install(TARGETS ${libname}
	LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" )
endfunction(make_plugin_frontend)


# We need a different name to avoid clashes with float libcsound
make_executable(csound-bin "${CS_MAIN_SRCS}" "${CSOUNDLIB}" csound)

message(STATUS "Building csLadspa")

make_plugin_frontend(csladspa "csladspa/csladspa.cpp" "${CSOUNDLIB}")
# We do not want the lib prefix
set_target_properties(csladspa PROPERTIES PREFIX "")

# CSBeats

check_deps(BUILD_CSBEATS FLEX_EXECUTABLE BISON_EXECUTABLE)

if(BUILD_CSBEATS)

    BISON_TARGET(csbeats_PARSER beats/beats.y ${CMAKE_CURRENT_BINARY_DIR}/beats.tab.c)
    FLEX_TARGET(csbeats_SCANNER beats/beats.l ${CMAKE_CURRENT_BINARY_DIR}/beatslex.yy.c)

    ADD_FLEX_BISON_DEPENDENCY(csbeats_SCANNER csbeats_PARSER)

    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/beats)

    set(csbeats_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/beats/main.c
        ${FLEX_csbeats_SCANNER_OUTPUTS}
        ${BISON_csbeats_PARSER_OUTPUTS})

    make_executable(csbeats "${csbeats_SRCS}" "m")

endif()

#PD Interface
if(WIN_32)
    check_deps(BUILD_PD_CLASS PD_HEADER_PATH PD_LIBRARY)
else()
    check_deps(BUILD_PD_CLASS PD_HEADER_PATH)
endif()
if(BUILD_PD_CLASS)
    include_directories(${PD_HEADER_PATH})
    if(LINUX)
        set(pdname "csound6~.pd_linux")
    elseif(APPLE)
        set(pdname "csound6~.pd_darwin")
    elseif(WIN32)
        set(pdname "csound6~.dll")
    endif()
    add_library(${pdname} MODULE csoundapi_tilde/csoundapi_tilde.c)
    if(WIN32)
        target_link_libraries (${pdname} ${CSOUNDLIB} ${PD_LIBRARY})
        set_target_properties(${pdname}  PROPERTIES "LINK_FLAGS"
            "-Wl,--allow-multiple-definition")
    else()
        target_link_libraries (${pdname} ${CSOUNDLIB})
    endif()
    set_target_properties(${pdname} PROPERTIES
        PREFIX ""
        SUFFIX ""
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})
    if(APPLE)
        set_target_properties(${pdname}  PROPERTIES "LINK_FLAGS"
            "-flat_namespace -undefined suppress")
    endif(APPLE)
    install(TARGETS ${pdname}
        LIBRARY DESTINATION ${LIBRARY_INSTALL_DIR})
endif()


#WinSound
check_deps(BUILD_WINSOUND FLTK_FOUND)
if(BUILD_WINSOUND)
    set(WINSOUND_FL ${CMAKE_CURRENT_SOURCE_DIR}/winsound/winsound.fl)
    set(WINSOUND_CXX ${CMAKE_CURRENT_BINARY_DIR}/winsound.cxx)
    set(WINSOUND_H ${CMAKE_CURRENT_BINARY_DIR}/winsound.h)
    set_source_files_properties(${WINSOUND_CXX} GENERATED)
    set_source_files_properties(${WINSOUND_H} GENERATED)
    add_custom_target(winsound_fl COMMAND fluid -c -o ${WINSOUND_CXX} -h $ --{WINSOUND_H} ${WINSOUND_FL})

    set(WINSOUND_SRCS ${WINSOUND_CXX} winsound/main.cxx)

    make_executable(winsound "${WINSOUND_SRCS}" "${FLTK_LIBRARIES}")
    target_link_libraries (winsound ${CSOUNDLIB})
    add_dependencies(winsound winsound_fl)
    include_directories(${FLTK_INCLUDE_DIR})
    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/winsound)


endif()

add_subdirectory(CsoundAC)
add_subdirectory(CsoundVST)
add_subdirectory(max_csound_tilde)

=== include/CMakeLists.txt ===
file(GLOB csheaders RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.h*")

# These don't live here... but we list them here to have all headers
# in one place
list(APPEND csheaders
    ../interfaces/CsoundFile.hpp
    ../interfaces/CppSound.hpp
    ../interfaces/filebuilding.h
    ../interfaces/csPerfThread.hpp)

set(csacheaders
    ../frontends/CsoundAC/Cell.hpp
    ../frontends/CsoundAC/ChordLindenmayer.hpp
    ../frontends/CsoundAC/Composition.hpp
    ../frontends/CsoundAC/Conversions.hpp
    ../frontends/CsoundAC/Counterpoint.hpp
    ../frontends/CsoundAC/CounterpointNode.hpp
    ../frontends/CsoundAC/Event.hpp
    ../frontends/CsoundAC/Exception.hpp
    ../frontends/CsoundAC/Hocket.hpp
    ../frontends/CsoundAC/ImageToScore.hpp
    ../frontends/CsoundAC/Lindenmayer.hpp
    ../frontends/CsoundAC/MCRM.hpp
    ../frontends/CsoundAC/Midifile.hpp
    ../frontends/CsoundAC/MusicModel.hpp
    ../frontends/CsoundAC/Node.hpp
    ../frontends/CsoundAC/OrchestraNode.hpp
    ../frontends/CsoundAC/Platform.hpp
    ../frontends/CsoundAC/Random.hpp
    ../frontends/CsoundAC/Rescale.hpp
    ../frontends/CsoundAC/Score.hpp
    ../frontends/CsoundAC/ScoreModel.hpp
    ../frontends/CsoundAC/ScoreNode.hpp
    ../frontends/CsoundAC/Sequence.hpp
    ../frontends/CsoundAC/Shell.hpp
    ../frontends/CsoundAC/Silence.hpp
    ../frontends/CsoundAC/Soundfile.hpp
    ../frontends/CsoundAC/StrangeAttractor.hpp
    ../frontends/CsoundAC/System.hpp
    ../frontends/CsoundAC/Voicelead.hpp
    ../frontends/CsoundAC/VoiceleadingNode.hpp
    )

set(csvstheaders
    frontends/CsoundVST/CsoundVstFltk.hpp
    frontends/CsoundVST/CsoundVST.hpp
    frontends/CsoundVST/CsoundVstUi.h
    frontends/CsoundVST/Platform.hpp
    frontends/CsoundVST/ScoreGenerator.hpp
    frontends/CsoundVST/ScoreGeneratorVstFltk.hpp
    frontends/CsoundVST/ScoreGeneratorVst.hpp
    frontends/CsoundVST/ScoreGeneratorVstUi.h
    )

set(csheaders ${csheaders} PARENT_SCOPE)

if(NOT APPLE)
    INSTALL(FILES ${csheaders} DESTINATION ${HEADER_INSTALL_DIR})
endif()

IF( BUILD_CSOUND_AC )
    INSTALL(FILES ${csacheaders} DESTINATION ${HEADER_INSTALL_DIR})
endif()

# Enable this when we build CsoundVST
#INSTALL(FILES ${csvstheaders} DESTINATION ${HEADER_INSTALL_DIR})

=== interfaces/CMakeLists.txt ===
## Language bindings ##

# C++ INTERFACE LIBRARY

option(BUILD_CXX_INTERFACE "Build the C++ interface library" ON)
option(BUILD_PYTHON_INTERFACE "Build the Python interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_JAVA_INTERFACE "Build the Java interface (needs BUILD_CXX_INTERFACE)" ON)
option(BUILD_LUA_INTERFACE "Build the Lua interface (needs BUILD_CXX_INTERFACE)" ON)

if(BUILD_CXX_INTERFACE)
    message(STATUS "Building C++ interface library")
    set(libcsnd6_SRCS
        CppSound.cpp
        CsoundFile.cpp
        Soundfile.cpp
        csPerfThread.cpp
        cs_glue.cpp
        filebuilding.cpp)
    set(libcsnd6_LIBS ${LIBSNDFILE_LIBRARY})
    set(libcsnd6_CFLAGS "")
    list(APPEND libcsnd6_LIBS ${CSOUNDLIB})

    add_library(libcsnd6 SHARED ${libcsnd6_SRCS})
    target_link_libraries(libcsnd6 ${libcsnd6_LIBS})
    set_target_properties(libcsnd6 PROPERTIES
        LINK_INTERFACE_LIBRARIES ""
        SOVERSION ${APIVERSION}
        OUTPUT_NAME csnd6
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_BIN_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
        )
    if(${libcsnd6_CFLAGS})
        add_compiler_flags(${libcsnd6_CFLAGS} TARGETS libcsnd6)
    endif()

    install(TARGETS libcsnd6
        LIBRARY DESTINATION "${LIBRARY_INSTALL_DIR}"
        ARCHIVE DESTINATION "${LIBRARY_INSTALL_DIR}")

endif()


# SWIG INTERFACES
FIND_PACKAGE(SWIG 2.0)
FIND_PACKAGE(PythonLibs)
FIND_PACKAGE(JNI)
FIND_PACKAGE(Java)

find_library(LUAJIT_LIBRARY luajit)
if(NOT LUAJIT_LIBRARY)
    find_library(LUAJIT_LIBRARY luajit-5.1)
endif()
find_path(LUA_H_PATH luajit-2.0/lua.h)

MESSAGE(STATUS ${PYTHON_LIBRARY})

check_deps(BUILD_PYTHON_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE PYTHONLIBS_FOUND)
check_deps(BUILD_JAVA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE JNI_FOUND JAVA_FOUND)
check_deps(BUILD_LUA_INTERFACE SWIG_FOUND BUILD_CXX_INTERFACE  LUAJIT_LIBRARY LUA_H_PATH)

if(BUILD_PYTHON_INTERFACE OR BUILD_JAVA_INTERFACE OR BUILD_LUA_INTERFACE)

    include(${SWIG_USE_FILE})

    include_directories(${CMAKE_CURRENT_SOURCE_DIR})

    set(CMAKE_SWIG_FLAGS ${libcsound_CFLAGS})
    list(APPEND CMAKE_SWIG_FLAGS "-includeall" "-verbose")

    if(USE_DOUBLE)
        list(APPEND CMAKE_SWIG_FLAGS "-DUSE_DOUBLE")
    endif(USE_DOUBLE)

    set(CMAKE_SWIG_OUTDIR ${BUILD_LIB_DIR})

    if(BUILD_PYTHON_INTERFACE)
        INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})

        if(WIN32)
            set(swigpython_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} ${PYTHON_LIBRARY} libcsnd6)
        else()
            # Note: Do not link to PYTHON_LIBRARY so that it can be loaded in any python 
            set(swigpython_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd6)
        endif()
# Had:     	    SWIG_FLAGS "-threads"

        SET_SOURCE_FILES_PROPERTIES(python_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME csnd6)

        set(SWIG_MODULE_csnd6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)

        SWIG_ADD_MODULE(csnd6 python python_interface.i)
        SWIG_LINK_LIBRARIES(csnd6 ${swigpython_LIBS})

        set_target_properties(${SWIG_MODULE_csnd6_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

	if(APPLE)
	    set_target_properties(${SWIG_MODULE_csnd6_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
	endif()

        install(TARGETS ${SWIG_MODULE_csnd6_REAL_NAME}
            LIBRARY DESTINATION "${PYTHON_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${PYTHON_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd6.py
            DESTINATION ${PYTHON_MODULE_INSTALL_DIR})

    endif()

    if(BUILD_JAVA_INTERFACE)
        # The java package needs this unset or it will litter us with .java files
        unset(CMAKE_SWIG_OUTDIR)
        INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})

      	if(LINUX)
            set(swigjava_LIBS ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd6)
        else()
            set(swigjava_LIBS ${JNI_LIBRARIES} ${CSOUNDLIB} ${LIBSNDFILE_LIBRARY} libcsnd6)
        endif()

        list(APPEND javaSwigOptions -package csnd6 -includeall)
        SET_SOURCE_FILES_PROPERTIES(java_interface.i PROPERTIES CPLUSPLUS ON)
        SET_SOURCE_FILES_PROPERTIES(java_interface.i PROPERTIES SWIG_FLAGS "${javaSwigOptions}")

        set(SWIG_MODULE__jcsound6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)

        SWIG_ADD_MODULE(_jcsound6 java java_interface.i)
        SWIG_LINK_LIBRARIES(_jcsound6 ${swigjava_LIBS})

        ADD_CUSTOM_COMMAND(TARGET _jcsound6
            POST_BUILD
            COMMAND cmake -E make_directory ./csnd6
            COMMAND ${JAVA_COMPILE} *.java -source 1.6 -target 1.6 -d .
            COMMAND ${JAVA_ARCHIVE} cf ../csnd6.jar csnd6
            COMMENT "Building JAVA package csnd6.jar")

        set_target_properties(_jcsound6 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR})

        install(TARGETS _jcsound6
            LIBRARY DESTINATION "${JAVA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${JAVA_MODULE_INSTALL_DIR}")
        install(FILES ${BUILD_LIB_DIR}/csnd6.jar
            DESTINATION ${JAVA_MODULE_INSTALL_DIR})

    endif()

    if(BUILD_LUA_INTERFACE)
        set(swiglua_LIBS ${LUAJIT_LIBRARY} ${CSOUNDLIB} libcsnd6)

        SET_SOURCE_FILES_PROPERTIES(lua_interface.i
            PROPERTIES CPLUSPLUS ON
            SWIG_MODULE_NAME luaCsnd6)


        set(SWIG_MODULE_luaCsnd6_EXTRA_DEPS ../include/csound.h ../include/cfgvar.h ../include/csound.hpp
                                        cs_glue.hpp csPerfThread.hpp CsoundFile.hpp
                                        CppSound.hpp filebuilding.h Soundfile.hpp)

        SWIG_ADD_MODULE(luaCsnd6 lua lua_interface.i)
        SWIG_LINK_LIBRARIES(luaCsnd6 ${swiglua_LIBS})

        include_directories(${LUA_H_PATH}/luajit-2.0)

      	if(APPLE)
            set_target_properties(${SWIG_MODULE_luaCsnd6_REAL_NAME} PROPERTIES
                LINK_FLAGS "-undefined dynamic_lookup")
      	endif()

        set_target_properties(${SWIG_MODULE_luaCsnd6_REAL_NAME} PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            LIBRARY_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            ARCHIVE_OUTPUT_DIRECTORY ${BUILD_LIB_DIR}
            PREFIX "")

        install(TARGETS luaCsnd6
            LIBRARY DESTINATION "${LUA_MODULE_INSTALL_DIR}"
            ARCHIVE DESTINATION "${LUA_MODULE_INSTALL_DIR}")

    endif()

endif()

=== nacl/Makefile ===
# Makefile for NaCl Csound lib
# V Lazzarini 2013

VALID_TOOLCHAINS := pnacl newlib glibc
LOCAL_INCLUDES := -I../Engine -I../include -I../H -I. -I..
NACL_CFLAGS ?= -Wno-long-long
NACL_CXXFLAGS ?= -Wno-long-long

NACL_SDK_ROOT ?= $(abspath $(CURDIR)/../../..)
include $(NACL_SDK_ROOT)/tools/common.mk

CSOUND_SRC_ROOT := ../

TARGET = csound
CFLAGS = -O3  $(LOCAL_INCLUDES) $(NACL_INCLUDES) -DENABLE_OPCODEDIR_WARNINGS -D__BUILDING_LIBCSOUND -DENABLE_NEW_PARSER -DLINUX -DHAVE_DIRENT_H -DHAVE_FCNTL_H -DHAVE_UNISTD_H -DHAVE_STDINT_H -DHAVE_SYS_TIME_H -DHAVE_SYS_TYPES_H -DHAVE_TERMIOS_H -DHAVE_STRTOK_R -DNACL -Wno-format -Wno-empty-body

SOURCES := $(CSOUND_SRC_ROOT)/Engine/auxfd.c \
$(CSOUND_SRC_ROOT)/Engine/cfgvar.c \
$(CSOUND_SRC_ROOT)/Engine/corfiles.c \
$(CSOUND_SRC_ROOT)/Engine/entry1.c \
$(CSOUND_SRC_ROOT)/Engine/envvar.c \
$(CSOUND_SRC_ROOT)/Engine/extract.c \
$(CSOUND_SRC_ROOT)/Engine/fgens.c \
$(CSOUND_SRC_ROOT)/Engine/insert.c \
$(CSOUND_SRC_ROOT)/Engine/linevent.c \
$(CSOUND_SRC_ROOT)/Engine/memalloc.c \
$(CSOUND_SRC_ROOT)/Engine/memfiles.c \
$(CSOUND_SRC_ROOT)/Engine/musmon.c \
$(CSOUND_SRC_ROOT)/Engine/namedins.c \
$(CSOUND_SRC_ROOT)/Engine/rdscor.c \
$(CSOUND_SRC_ROOT)/Engine/scsort.c \
$(CSOUND_SRC_ROOT)/Engine/scxtract.c \
$(CSOUND_SRC_ROOT)/Engine/sort.c \
$(CSOUND_SRC_ROOT)/Engine/sread.c \
$(CSOUND_SRC_ROOT)/Engine/swritestr.c \
$(CSOUND_SRC_ROOT)/Engine/twarp.c \
$(CSOUND_SRC_ROOT)/Engine/csound_type_system.c \
$(CSOUND_SRC_ROOT)/Engine/csound_standard_types.c \
$(CSOUND_SRC_ROOT)/Engine/csound_data_structures.c \
$(CSOUND_SRC_ROOT)/Engine/pools.c \
$(CSOUND_SRC_ROOT)/InOut/libsnd.c \
$(CSOUND_SRC_ROOT)/InOut/libsnd_u.c \
$(CSOUND_SRC_ROOT)/InOut/midifile.c \
$(CSOUND_SRC_ROOT)/InOut/midirecv.c \
$(CSOUND_SRC_ROOT)/InOut/midisend.c \
$(CSOUND_SRC_ROOT)/InOut/winascii.c \
$(CSOUND_SRC_ROOT)/InOut/windin.c \
$(CSOUND_SRC_ROOT)/InOut/window.c \
$(CSOUND_SRC_ROOT)/InOut/winEPS.c \
$(CSOUND_SRC_ROOT)/InOut/circularbuffer.c \
$(CSOUND_SRC_ROOT)/OOps/aops.c \
$(CSOUND_SRC_ROOT)/OOps/bus.c \
$(CSOUND_SRC_ROOT)/OOps/cmath.c \
$(CSOUND_SRC_ROOT)/OOps/diskin2.c \
$(CSOUND_SRC_ROOT)/OOps/disprep.c \
$(CSOUND_SRC_ROOT)/OOps/dumpf.c \
$(CSOUND_SRC_ROOT)/OOps/fftlib.c \
$(CSOUND_SRC_ROOT)/OOps/goto_ops.c \
$(CSOUND_SRC_ROOT)/OOps/midiinterop.c \
$(CSOUND_SRC_ROOT)/OOps/midiops.c \
$(CSOUND_SRC_ROOT)/OOps/midiout.c \
$(CSOUND_SRC_ROOT)/OOps/mxfft.c \
$(CSOUND_SRC_ROOT)/OOps/oscils.c \
$(CSOUND_SRC_ROOT)/OOps/pstream.c \
$(CSOUND_SRC_ROOT)/OOps/pvfileio.c \
$(CSOUND_SRC_ROOT)/OOps/pvsanal.c \
$(CSOUND_SRC_ROOT)/OOps/random.c \
$(CSOUND_SRC_ROOT)/OOps/remote.c \
$(CSOUND_SRC_ROOT)/OOps/schedule.c \
$(CSOUND_SRC_ROOT)/OOps/sndinfUG.c \
$(CSOUND_SRC_ROOT)/OOps/str_ops.c \
$(CSOUND_SRC_ROOT)/OOps/ugens1.c \
$(CSOUND_SRC_ROOT)/OOps/ugens2.c \
$(CSOUND_SRC_ROOT)/OOps/ugens2a.c \
$(CSOUND_SRC_ROOT)/OOps/ugens3.c \
$(CSOUND_SRC_ROOT)/OOps/ugens4.c \
$(CSOUND_SRC_ROOT)/OOps/ugens5.c \
$(CSOUND_SRC_ROOT)/OOps/ugens6.c \
$(CSOUND_SRC_ROOT)/OOps/ugtabs.c \
$(CSOUND_SRC_ROOT)/OOps/ugrw1.c \
$(CSOUND_SRC_ROOT)/OOps/ugrw2.c \
$(CSOUND_SRC_ROOT)/OOps/vdelay.c \
$(CSOUND_SRC_ROOT)/OOps/compile_ops.c \
$(CSOUND_SRC_ROOT)/Opcodes/babo.c \
$(CSOUND_SRC_ROOT)/Opcodes/bilbar.c \
$(CSOUND_SRC_ROOT)/Opcodes/compress.c \
$(CSOUND_SRC_ROOT)/Opcodes/eqfil.c \
$(CSOUND_SRC_ROOT)/Opcodes/Vosim.c \
$(CSOUND_SRC_ROOT)/Opcodes/pitch.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pitch0.c   \
$(CSOUND_SRC_ROOT)/Opcodes/spectra.c  \
$(CSOUND_SRC_ROOT)/Opcodes/ambicode1.c \
$(CSOUND_SRC_ROOT)/Opcodes/sfont.c  \
$(CSOUND_SRC_ROOT)/Opcodes/grain4.c  \
$(CSOUND_SRC_ROOT)/Opcodes/hrtferX.c  \
$(CSOUND_SRC_ROOT)/Opcodes/loscilx.c \
$(CSOUND_SRC_ROOT)/Opcodes/minmax.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pan2.c  \
$(CSOUND_SRC_ROOT)/Opcodes/afilters.c  \
$(CSOUND_SRC_ROOT)/Opcodes/phisem.c \
$(CSOUND_SRC_ROOT)/Opcodes/arrays.c \
$(CSOUND_SRC_ROOT)/Opcodes/hrtfopcodes.c  \
$(CSOUND_SRC_ROOT)/Opcodes/stackops.c  \
$(CSOUND_SRC_ROOT)/Opcodes/vbap.c  \
$(CSOUND_SRC_ROOT)/Opcodes/vbap1.c  \
$(CSOUND_SRC_ROOT)/Opcodes/vbap_n.c  \
$(CSOUND_SRC_ROOT)/Opcodes/vbap_zak.c   \
$(CSOUND_SRC_ROOT)/Opcodes/vaops.c  \
$(CSOUND_SRC_ROOT)/Opcodes/ugakbari.c  \
$(CSOUND_SRC_ROOT)/Opcodes/harmon.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pitchtrack.c  \
$(CSOUND_SRC_ROOT)/Opcodes/partikkel.c  \
$(CSOUND_SRC_ROOT)/Opcodes/shape.c  \
$(CSOUND_SRC_ROOT)/Opcodes/tabsum.c \
$(CSOUND_SRC_ROOT)/Opcodes/crossfm.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvlock.c  \
$(CSOUND_SRC_ROOT)/Opcodes/fareyseq.c  \
$(CSOUND_SRC_ROOT)/Opcodes/modmatrix.c  \
$(CSOUND_SRC_ROOT)/Opcodes/scoreline.c  \
$(CSOUND_SRC_ROOT)/Opcodes/modal4.c \
$(CSOUND_SRC_ROOT)/Opcodes/physutil.c  \
$(CSOUND_SRC_ROOT)/Opcodes/physmod.c  \
$(CSOUND_SRC_ROOT)/Opcodes/mandolin.c  \
$(CSOUND_SRC_ROOT)/Opcodes/singwave.c \
$(CSOUND_SRC_ROOT)/Opcodes/fm4op.c  \
$(CSOUND_SRC_ROOT)/Opcodes/moog1.c  \
$(CSOUND_SRC_ROOT)/Opcodes/shaker.c  \
$(CSOUND_SRC_ROOT)/Opcodes/bowedbar.c \
$(CSOUND_SRC_ROOT)/Opcodes/gab/tabmorph.c \
$(CSOUND_SRC_ROOT)/Opcodes/gab/hvs.c \
$(CSOUND_SRC_ROOT)/Opcodes/gab/sliderTable.c \
$(CSOUND_SRC_ROOT)/Opcodes/gab/newgabopc.c \
$(CSOUND_SRC_ROOT)/Opcodes/ftest.c \
$(CSOUND_SRC_ROOT)/Opcodes/hrtfearly.c \
$(CSOUND_SRC_ROOT)/Opcodes/hrtfreverb.c \
$(CSOUND_SRC_ROOT)/Opcodes/cpumeter.c \
$(CSOUND_SRC_ROOT)/Opcodes/gendy.c \
$(CSOUND_SRC_ROOT)/Opcodes/tl/sc_noise.c \
$(CSOUND_SRC_ROOT)/Top/argdecode.c \
$(CSOUND_SRC_ROOT)/Top/cscore_internal.c \
$(CSOUND_SRC_ROOT)/Top/cscorfns.c \
$(CSOUND_SRC_ROOT)/Top/csmodule.c \
$(CSOUND_SRC_ROOT)/Top/csound.c \
$(CSOUND_SRC_ROOT)/Top/getstring.c \
$(CSOUND_SRC_ROOT)/Top/main.c \
$(CSOUND_SRC_ROOT)/Top/new_opts.c \
$(CSOUND_SRC_ROOT)/Top/one_file.c \
$(CSOUND_SRC_ROOT)/Top/opcode.c \
$(CSOUND_SRC_ROOT)/Top/threads.c \
$(CSOUND_SRC_ROOT)/Top/utility.c \
$(CSOUND_SRC_ROOT)/Top/threadsafe.c \
$(CSOUND_SRC_ROOT)/Opcodes/ambicode.c       \
$(CSOUND_SRC_ROOT)/Opcodes/bbcut.c          \
$(CSOUND_SRC_ROOT)/Opcodes/biquad.c \
$(CSOUND_SRC_ROOT)/Opcodes/butter.c         \
$(CSOUND_SRC_ROOT)/Opcodes/clfilt.c         \
$(CSOUND_SRC_ROOT)/Opcodes/cross2.c \
$(CSOUND_SRC_ROOT)/Opcodes/dam.c            \
$(CSOUND_SRC_ROOT)/Opcodes/dcblockr.c       \
$(CSOUND_SRC_ROOT)/Opcodes/filter.c \
$(CSOUND_SRC_ROOT)/Opcodes/flanger.c        \
$(CSOUND_SRC_ROOT)/Opcodes/follow.c         \
$(CSOUND_SRC_ROOT)/Opcodes/fout.c \
$(CSOUND_SRC_ROOT)/Opcodes/freeverb.c       \
$(CSOUND_SRC_ROOT)/Opcodes/ftconv.c         \
$(CSOUND_SRC_ROOT)/Opcodes/ftgen.c \
$(CSOUND_SRC_ROOT)/Opcodes/gab/gab.c        \
$(CSOUND_SRC_ROOT)/Opcodes/gab/vectorial.c  \
$(CSOUND_SRC_ROOT)/Opcodes/grain.c \
$(CSOUND_SRC_ROOT)/Opcodes/locsig.c         \
$(CSOUND_SRC_ROOT)/Opcodes/lowpassr.c       \
$(CSOUND_SRC_ROOT)/Opcodes/metro.c \
$(CSOUND_SRC_ROOT)/Opcodes/midiops2.c       \
$(CSOUND_SRC_ROOT)/Opcodes/midiops3.c       \
$(CSOUND_SRC_ROOT)/Opcodes/newfils.c \
$(CSOUND_SRC_ROOT)/Opcodes/nlfilt.c         \
$(CSOUND_SRC_ROOT)/Opcodes/oscbnk.c         \
$(CSOUND_SRC_ROOT)/Opcodes/pluck.c \
$(CSOUND_SRC_ROOT)/Opcodes/repluck.c        \
$(CSOUND_SRC_ROOT)/Opcodes/reverbsc.c       \
$(CSOUND_SRC_ROOT)/Opcodes/seqtime.c \
$(CSOUND_SRC_ROOT)/Opcodes/sndloop.c        \
$(CSOUND_SRC_ROOT)/Opcodes/sndwarp.c        \
$(CSOUND_SRC_ROOT)/Opcodes/space.c \
$(CSOUND_SRC_ROOT)/Opcodes/spat3d.c         \
$(CSOUND_SRC_ROOT)/Opcodes/syncgrain.c      \
$(CSOUND_SRC_ROOT)/Opcodes/ugens7.c \
$(CSOUND_SRC_ROOT)/Opcodes/ugens9.c         \
$(CSOUND_SRC_ROOT)/Opcodes/ugensa.c         \
$(CSOUND_SRC_ROOT)/Opcodes/uggab.c \
$(CSOUND_SRC_ROOT)/Opcodes/ugmoss.c         \
$(CSOUND_SRC_ROOT)/Opcodes/ugnorman.c       \
$(CSOUND_SRC_ROOT)/Opcodes/ugsc.c \
$(CSOUND_SRC_ROOT)/Opcodes/wave-terrain.c   \
$(CSOUND_SRC_ROOT)/Opcodes/stdopcod.c \
$(CSOUND_SRC_ROOT)/Opcodes/ifd.c  \
$(CSOUND_SRC_ROOT)/Opcodes/partials.c  \
$(CSOUND_SRC_ROOT)/Opcodes/psynth.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvsbasic.c \
$(CSOUND_SRC_ROOT)/Opcodes/pvscent.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvsdemix.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvs_ops.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvsband.c \
$(CSOUND_SRC_ROOT)/Opcodes/pvsbuffer.c \
$(CSOUND_SRC_ROOT)/Opcodes/pvsgendy.c \
$(CSOUND_SRC_ROOT)/Opcodes/dsputil.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvadd.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvinterp.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvocext.c \
$(CSOUND_SRC_ROOT)/Opcodes/pvread.c  \
$(CSOUND_SRC_ROOT)/Opcodes/ugens8.c  \
$(CSOUND_SRC_ROOT)/Opcodes/vpvoc.c  \
$(CSOUND_SRC_ROOT)/Opcodes/pvoc.c \
$(CSOUND_SRC_ROOT)/Engine/csound_orc_semantics.c \
$(CSOUND_SRC_ROOT)/Engine/csound_orc_expressions.c \
$(CSOUND_SRC_ROOT)/Engine/csound_orc_optimize.c \
$(CSOUND_SRC_ROOT)/Engine/csound_orc_compile.c \
$(CSOUND_SRC_ROOT)/Engine/new_orc_parser.c \
$(CSOUND_SRC_ROOT)/Engine/symbtab.c \
$(CSOUND_SRC_ROOT)/Engine/cs_new_dispatch.c \
$(CSOUND_SRC_ROOT)/Engine/cs_par_base.c \
$(CSOUND_SRC_ROOT)/Engine/cs_par_orc_semantic_analysis.c \
$(CSOUND_SRC_ROOT)/Engine/cs_par_dispatch.c \
$(CSOUND_SRC_ROOT)/Top/server.c \
csound_orclex.c \
csound_prelex.c \
csound_orcparse.c \

# Build rules generated by macros from common.mk:
$(foreach src,$(SOURCES),$(eval $(call COMPILE_RULE,$(src),$(CFLAGS))))
$(eval $(call LIB_RULE,$(TARGET),$(SOURCES)))

=== po/CMakeLists.txt ===
# cmake 2.8.7 has a macro GETTEXT_PROCESS_PO_FILES
# We don't use it because it may be too new.
function(compile_po code _infile)
    set(_mofile "${CMAKE_CURRENT_BINARY_DIR}/${code}.mo")
    set(_pofile "${CMAKE_CURRENT_SOURCE_DIR}/${_infile}")
    add_custom_command(
        TARGET "translations"
        SOURCE ${_pofile}
        COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} ARGS -o ${_mofile} ${_pofile}
        OUTPUTS ${_mofile}
        )
    INSTALL(FILES ${_mofile}
        DESTINATION ${LOCALE_INSTALL_DIR}/${code}/LC_MESSAGES/
        RENAME "csound6.mo"
        )
    add_custom_target(${code}.mo ALL DEPENDS ${_mofile})
    add_dependencies(translations ${code}.mo)
endfunction(compile_po)

if(USE_GETTEXT)
    ADD_CUSTOM_TARGET(translations ALL echo "Building translations")
    compile_po(en_US american.po)
    compile_po(es_CO es_CO.po)
    compile_po(fr french.po)
    compile_po(de german.po)
    compile_po(it italian.po)
    compile_po(ro romanian.po)
    compile_po(ru russian.po)
endif()

=== util/CMakeLists.txt ===
# UTILITY PLUGIN AND PROGRAMS

set(stdutil_SRCS
    atsa.c          cvanal.c        dnoise.c    envext.c    
    het_export.c    het_import.c    hetro.c     lpanal.c 
    lpc_export.c    lpc_import.c    mixer.c     pvanal.c        
    pv_export.c     pv_import.c     pvlook.c    scale.c
    sndinfo.c       srconv.c        std_util.c  xtrct.c
    scope.c
    ../SDIF/sdif.c)

make_plugin(stdutil "${stdutil_SRCS}" m ${LIBSNDFILE_LIBRARY})
add_dependency_to_framework(stdutil ${LIBSNDFILE_LIBRARY})

if(BUILD_UTILITIES) 
    make_utility(atsa        atsa_main.c)
    make_utility(csanalyze   csanalyze.c)
    make_utility(cvanal      cvl_main.c)
    make_utility(dnoise      dnoise_main.c)
    make_utility(envext      env_main.c)
    make_utility(extractor   xtrc_main.c)
    make_utility(het_export  hetx_main.c)
    make_utility(het_import  heti_main.c)
    make_utility(hetro       het_main.c)
    make_utility(lpanal      lpc_main.c)
    make_utility(lpc_export  lpcx_main.c)
    target_link_libraries(lpc_export m)
    make_utility(lpc_import  lpci_main.c)
    make_executable(mixer-bin   mixer_main.c   "${CSOUNDLIB}" mixer)
    make_utility(pvanal      pvc_main.c)
    make_utility(pvlook      pvl_main.c)
    make_utility(pv_export   pvx_main.c)
    make_utility(pv_import   pvi_main.c)
    make_utility(scale       scale_main.c)
    make_utility(sndinfo     sndinfo_main.c)
    make_utility(srconv      srconv_main.c)
    make_utility(scope       scope_main.c)          
endif()

=== util1/CMakeLists.txt ===
#extra utilities

make_utility(scsort      sortex/smain.c)
make_utility(extract     sortex/xmain.c)

if(CMAKE_COMPILER_IS_GNUCC)
    if(HAVE_UNISTD_H)
      add_definitions("-DHAVE_UNISTD_H")
    endif()
    make_utility(cs         csd_util/cs.c)
    
    set(csb64enc_SRCS 
        csd_util/base64.c csd_util/csb64enc.c)
    make_utility(csb64enc "${csb64enc_SRCS}")
    
    set(makecsd_SRCS 
        csd_util/base64.c csd_util/makecsd.c)
    make_utility(makecsd "${makecsd_SRCS}")
    
    set(scot_SRCS 
        scot/scot_main.c scot/scot.c)
    make_utility(scot "${scot_SRCS}")
endif()

=== Opcodes/stk/CMakeLists.txt ===
option(BUILD_STK_OPCODES "Build the stk opcodes" ON)

if(BUILD_STK_OPCODES)
    find_library(STK_LIBRARY stk)
    if(STK_LIBRARY)
        find_path(STK_INCLUDE_DIR Stk.h
            /usr/include/stk
            /usr/local/include/stk)
        
        check_deps(BUILD_STK_OPCODES STK_INCLUDE_DIR)
        if(STK_INCLUDE_DIR)
            include_directories(${STK_INCLUDE_DIR})

            make_plugin(stk-ops stkOpcodes.cpp ${STK_LIBRARY})

            set_target_properties(stk-ops PROPERTIES
                OUTPUT_NAME stk)
        endif()
    else()

        set(stk_remove_srcs     
            src/InetWvIn.cpp    src/InetWvOut.cpp
            src/Mutex.cpp       src/RtAudio.cpp
            src/RtMidi.cpp
            src/RtWvIn.cpp      src/RtWvOut.cpp
            src/Socket.cpp      src/TcpClient.cpp
            src/TcpServer.cpp   src/Thread.cpp
            src/UdpSocket.cpp)
        
        file(GLOB stk_srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} src/*)
	       
        list(REMOVE_ITEM stk_srcs ${stk_remove_srcs})

        list(APPEND stk_srcs stkOpcodes.cpp)
  
        # Assume that if this file exists, then we have the sources
        find_file(STK_FOUND
            NAMES src/InetWvIn.cpp
            HINTS ${CMAKE_CURRENT_SOURCE_DIR})

        find_path(STK_INCLUDE_DIR Stk.h ./include)            

        check_deps(BUILD_STK_OPCODES STK_FOUND STK_INCLUDE_DIR)

        if(BUILD_STK_OPCODES)

            include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
            include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/stk)
            include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

            make_plugin(stk "${stk_srcs}")

            set(stkdefs "-D__STK_REALTIME__")
            if(APPLE)
                list(APPEND stkdefs "-D__OS_MACOSX__")
                list(REMOVE_ITEM stkdefs "-D__STK_REALTIME__")
            elseif(LINUX)
                list(APPEND stkdefs "-D__OS_LINUX__")
                list(APPEND stkdefs "-D__LINUX_ALSA__")
            elseif(WIN32)
                list(APPEND stkdefs "-D__OS_WINDOWS__")
            endif()
    
            if(BIG_ENDIAN)
                list(APPEND stkdefs "-D__BIG_ENDIAN__")
            else()
                list(APPEND stkdefs "-D__LITTLE_ENDIAN__")
            endif()

            add_compiler_flags(${stkdefs} TARGETS stk)

        endif()
    endif()
endif()

=== examples/java/Makefile ===

all: CSDPlayer.jar CsoundEditor.jar

CSDPlayer.jar: CSDPlayer.java CSDPlayer.mf
	-rm -r *.class csnd6/*
	-rmdir csnd6
	javac -classpath ../../csnd6.jar $<
	jar xf ../../csnd6.jar csnd6
	jar cfm $@ CSDPlayer.mf csnd6 *.class
	jar i $@
	-rm -r *.class csnd6/*
	-rmdir csnd6

CsoundEditor.jar: CsoundEditor.java CsoundEditor.mf
	-rm -r *.class csnd6/*
	-rmdir csnd6
	javac -classpath ../../csnd6.jar $<
	jar xf ../../csnd6.jar csnd6
	jar cfm $@ CsoundEditor.mf csnd6 *.class
	jar i $@
	-rm -r *.class csnd6/*
	-rmdir csnd6

clean:
	-rm *.jar *.class csnd6/*
	-rmdir csnd6

=== debian/changelog ===
csound (1:6.02~dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Felipe Sateler <fsateler@debian.org>  Wed, 22 Jan 2014 10:08:39 -0300

=== debian/control ===
Source: csound
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Felipe Sateler <fsateler@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
 Forrest Cahoon <forrest.cahoon@gmail.com>
Build-Depends: cdbs (>= 0.4.111~),
 debhelper,
 dh-buildinfo,
 python,
 devscripts,
 cmake (>= 2.8.3),
 libsndfile1-dev,
 libasound2-dev [linux-any],
 libjack-dev,
 portaudio19-dev,
 libportmidi-dev,
 libpulse-dev,
 swig,
 liblua5.1-0-dev,
 python-dev (>= 2.6.6-3~),
 puredata-dev,
 default-jdk,
 libfltk1.1-dev,
 libfluidsynth-dev,
 liblo-dev,
 fluid,
 ladspa-sdk,
 libboost-dev,
 libboost-serialization-dev,
 libpng-dev,
 dssi-dev,
 libstk0-dev,
 libgmm++-dev,
 bison (>= 2.6),
 flex,
 libportsmf-dev,
 libeigen3-dev
Build-Depends-Indep:
 doxygen,
 graphviz,
 ttf-dejavu,
 dh-linktree,
 libjs-jquery
Standards-Version: 3.9.4
Vcs-Git: git://git.debian.org/git/pkg-multimedia/csound
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/csound.git
Homepage: http://www.csounds.com

Package: csound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcsound64-5.1 (<< 1:5.08.2~dfsg-1)
Recommends: csound-utils, csound-manpages
Description: powerful and versatile sound synthesis software
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.

Package: csound-data
Architecture: all
Depends: ${misc:Depends}
Breaks: csound (<< 1:5.13.0~dfsg-4)
Description: data files used by the csound library
 This package includes the architecture-independent data files used by
 the csound library or plugins.
 .
 For more information on Csound see the csound package.

Package: csound-utils
Architecture: any
Depends: ${shlibs:Depends}, csound, ${misc:Depends}
Description: miscellaneous utilities for the Csound system
 This package contains several utilities which may be useful with
 Csound.
 These utilities aid in score creation, sound analysis and sound 
 transformations.

Package: libcsound64-6.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, csound-data
Recommends: csound, stk
Breaks: csound (<< 1:5.07.0.dfsg-1), csound-gui (<< 1:6.00.1~dfsg-3)
Replaces: csound-gui (<< 1:6.00.1~dfsg-3)
Description: main library for Csound
 This package contains the library which provides most of the Csound
 functionality. This library was built using 64-bit precision for the
 calculations (this doesn't mean you need a 64-bit processor).
 .
 For more information on Csound, see the csound package.

Package: libcsnd6-java
Architecture: any
Section: java
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: csound
Suggests: java-virtual-machine
Description: Java bindings for the Csound API
 These are the java bindings for the Csound API.
 .
 For more information on Csound, see the csound package

Package: libcsound64-dev
Architecture: all
Section: libdevel
Depends: libcsound64-6.0 (>= ${source:Version}), libcsound64-6.0 (<< ${source:Version}.1~), ${misc:Depends}
Description: development files for Csound
 This package contains the development files needed to build programs
 linking to the Csound library.
 .
 For more information on Csound, see the csound package.

Package: libcsnd-dev
Architecture: all
Section: libdevel
Depends: libcsnd6-6.0 (>= ${source:Version}), libcsnd6-6.0 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsnd5.1
Suggests: liblua5.1-luacsnd
Provides: liblua5.1-luacsnd-dev
Description: development files for Csound -- C++ API
 This package contains the development files needed to build programs
 using the C++ bindings to the Csound library. It also includes the
 development symlink for the lua module, but you have to manually
 install liblua5.1-luacsnd for that to work.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac-dev
Architecture: all
Section: libdevel
Depends: libcsoundac6.0 (>= ${source:Version}), libcsoundac6.0 (<< ${source:Version}.1~), ${misc:Depends}
Replaces: libcsoundac5.1
Description: development files for CsoundAC
 This package contains the development files needed to build programs
 using the CsoundAC algorithmic composition system.
 .
 For more information on Csound and CsoundAC, see the csound and
 csoundac packages.

Package: pd-csound
Architecture: any
Depends: csound, puredata | pd, ${shlibs:Depends}, ${misc:Depends}
Description: Csound external for PureData
 This is the csound6~ opcode for PureData.
 .
 For more information on Csound or pureData, see the respective
 packages.

Package: python-csound
Architecture: any
Section: python
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for Csound
 This is the Python binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsnd6-6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ bindings for the Csound API
 This is the C++ binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: liblua5.1-luacsnd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: liblua5.1-luacsnd5.2
Replaces: liblua5.1-luacsnd5.2
Description: Lua bindings for the Csound API
 This is the Lua binding for the Csound API.
 .
 For more information on Csound, see the csound package.

Package: libcsoundac6.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Csound Algorithmic Composition library
 This is the core library for CsoundAC. It provides all the CsoundAC
 functionality. It also contains the development files to create C++
 programs.
 .
 For more information on Csound, see the csound package.

Package: python-csoundac
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, python-csound, ${misc:Depends}
Provides: ${python:Provides}
Description: Python bindings for CsoundAC
 This is the Python interface to the Csound Algorithmic Composition
 library.
 .
 For more information on Csound, see the csound package.

Package: csladspa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ladspa-plugin
Description: LADSPA plugin for Csound
 This plugin enables the creation of LADSPA plugins with the Csound
 language.
 .
 For more information on Csound or LADSPA, see the csound or ladspa-sdk
 packages, respectively.

Package: libcsound64-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: csound, libcsound64-dev
Description: Csound API documentation
 This package contains the API documentation for the Csound library in
 HTML format.
 .
 For more information on Csound, see the csound package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2007-2009 Felipe Sateler <fsateler@gmail.com>
# Copyright © 2008-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for CSound
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DEB_PYTHON_MODULE_PACKAGES = python-csound python-csoundac
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/python-module.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/pd.mk

DEB_UPSTREAM_URL = http://downloads.sourceforge.net/csound

# Adjustments for unusual upstream tarballs:
# * capitalized project name
# * no dash between project name and version
# * version number included in top folder inside tarball
DEB_UPSTREAM_PACKAGE = Csound
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/(\-|~rc[0-9])//g

DEB_UPSTREAM_TARBALL_MD5 = c99a890eb771a7626768ad7cec579958

# Non-DFSG license: limited to educational and research purposes
DEB_UPSTREAM_REPACKAGE_EXCLUDES = ./Opcodes/scansyn*
# Embedded tarball contains possibly source-less python binary
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./csound5_osx_installer_files.tar.gz
# Contains explicit copyright but lack licensing info
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./samples/VintageDreamsWaves-v2.sf2
# Unused, includes code from other projects
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./dependencies/
# Unused, we are already repackaging
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./iOS/ ./android/

# Skip some data files, in addition to the default debian files
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(samples/hrtf-.*\.dat|debian/(changelog|copyright(|_hints|_newhints)))$

# Common docs for all packages
DEB_INSTALL_DOCS_ALL = readme-csound6.txt AUTHORS

# Core options of csound
DEB_CMAKE_EXTRA_FLAGS = \
	-DBUILD_RELEASE=ON \
	-DFAIL_MISSING=ON \
	-DUSE_DOUBLE=ON \
	-DUSE_GETTEXT=ON \
	-DBUILD_STATIC_LIBRARY=OFF \
	-DUSE_OPEN_MP=ON \
	-DUSE_LRINT=ON \
	-DBUILD_UTILITIES=ON \
	-DBUILD_NEW_PARSER=ON \
	-DNEW_PARSER_DEBUG=OFF \
	-DBUILD_MULTI_CORE=ON \
	-DBUILD_CATALOG=OFF \
	-DBUILD_TESTS=OFF \
	-DUSE_COMPILER_OPTIMIZATIONS=OFF \

ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ATOMIC_BUILTINS=ON
else
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ATOMIC_BUILTINS=OFF
endif

# I/O plugins
DEB_CMAKE_EXTRA_FLAGS += \
	-DUSE_PULSEAUDIO=ON \
	-DUSE_PORTAUDIO=ON \
	-DUSE_PORTMIDI=ON \
	-DUSE_COREMIDI=OFF \
	-DUSE_AUDIOUNIT=OFF \
	-DUSE_JACK=ON
ifeq "$(DEB_HOST_ARCH_OS)" "linux"
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ALSA=ON
else
	DEB_CMAKE_EXTRA_FLAGS += -DUSE_ALSA=OFF
endif

# Optional opcodes
DEB_CMAKE_EXTRA_FLAGS += \
	-DUSE_FLTK=ON \
	-DBUILD_STK_OPCODES=ON \
	-DBUILD_VIRTUAL_KEYBOARD=ON \
	-DBUILD_DSSI_OPCODES=ON \
	-DBUILD_CHUA_OPCODES=ON \
	-DBUILD_DSSI_OPCODES=ON \
	-DBUILD_FLUID_OPCODES=ON \
	-DBUILD_JACK_OPCODES=ON \
	-DBUILD_LINEAR_ALGEBRA_OPCODES=ON \
	-DBUILD_OSC_OPCODES=ON \
	-DBUILD_IMAGE_OPCODES=ON \
	-DBUILD_PYTHON_OPCODES=ON \
	-DBUILD_LUA_OPCODES=ON \
	-DBUILD_PD_CLASS=ON \
	-DBUILD_WIIMOTE_OPCODES=OFF \
	-DBUILD_P5GLOVE_OPCODES=OFF \
	-DUSE_CURL=OFF \
	-DBUILD_VST4CS_OPCODES=OFF \
	-DBUILD_FAUST_OPCODES=OFF \


# Language Wrappers
# TODO: build for all Python versions (not only current default one)
# Force build of only the default one
# UGLY HACK: abuse this variable to pass an appropriate -V option
DEB_DH_PYTHONHELPER_ARGS_ALL = -V $(shell pyversions -vd)
DEB_CMAKE_EXTRA_FLAGS += \
	-DBUILD_CXX_INTERFACE=ON \
	-DBUILD_PYTHON_INTERFACE=ON \
	-DBUILD_JAVA_INTERFACE=ON \
	-DBUILD_LUA_INTERFACE=ON \

# Frontends
DEB_CMAKE_EXTRA_FLAGS += \
	-DBUILD_CSBEATS=ON \
	-DUSE_SYSTEM_PORTSMF=ON \
	-DBUILD_MAX_CSOUND_TILDE=OFF \
	-DBUILD_CSOUND_AC=ON \
	-DBUILD_CSOUND_AC_PYTHON_INTERFACE=ON \
	-DBUILD_CSOUND_AC_LUA_INTERFACE=ON


# This is a huge optimization boost
ifneq "$(filter amd64 i386, $(DEB_HOST_ARCH_CPU))" ""
	MTUNE = ON
endif

# Python >= 2.6 should install to dist-packages instead of site-packages
# Since 2.5 is the only version < 2.6 we support, we test for that.
# TODO: Use simpler second form when 2.6 is default in a stable release
PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/$(if $(call cdbs_streq,$(cdbs_python_current_version),2.5),site-packages,dist-packages)
#PYLIBPATH = usr/lib/$(cdbs_python_current_binary)/dist-packages
# Path with PREFIX removed
PYLIBPATH2 = lib/$(cdbs_python_current_binary)/$(if $(call cdbs_streq,$(cdbs_python_current_version),2.5),site-packages,dist-packages)

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX = $(DEB_HOST_GNU_TYPE)-g++

# Support parallel building if enabled in DEB_BUILD_OPTIONS
DEB_BUILD_PARALLEL = 1

DEB_DH_INSTALL_SOURCEDIR = debian/tmp

DEB_SCONS_INSTALL_OPTIONS = instdir=$(CURDIR)/debian/tmp
DEB_SCONS_INSTALL_TARGET = install=1


build/libcsound64-doc:: build-doxygen-stamp
build-doxygen-stamp:
	mkdir -p doc/csound
	doxygen
	touch $@

# Put aside upstream cruft before build but after licensecheck
pre-build:: Custom.cmake
Custom.cmake: debian/Custom.cmake
	sed -e 's,@PYLIBPATH@,$(PYLIBPATH2),' -e 's,@MTUNE@,$(MTUNE),' \
		debian/Custom.cmake > \
		Custom.cmake

clean::
	rm -f build-arch-stamp build-indep-stamp manpages-stamp \
		build-doxygen-stamp
	rm -f Custom.cmake
	rm -rf doc/csound
# fail-missing stuff
	rm -f debian/cdbs-install-diff
	rm -f debian/cdbs-reduced-install-list
	rm -f debian/cdbs-reduced-package-list

TMPDIR = $(CURDIR)/debian/tmp

install/csound-data::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/csound/hrtf
	cp samples/*.dat $(CURDIR)/debian/tmp/usr/share/csound/hrtf

# avoid conflict with extract
install/csound-utils::
	mv $(CURDIR)/debian/tmp/usr/bin/extract \
		$(CURDIR)/debian/tmp/usr/bin/csound_extract

install/pd-csound::
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/pd/extra
	mv $(CURDIR)/debian/tmp/usr/lib/csound6~.pd_linux \
		$(CURDIR)/debian/tmp/usr/lib/pd/extra

install/libcsnd6-java::
	mkdir -p $(CURDIR)/debian/tmp/usr/share/java
	mv $(CURDIR)/debian/tmp/usr/lib/csnd6.jar \
		$(CURDIR)/debian/tmp/usr/share/java/csnd6-$(DEB_UPSTREAM_VERSION).jar
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/jni
	mv $(CURDIR)/debian/tmp/usr/lib/lib_jcsound6.so \
		$(CURDIR)/debian/tmp/usr/lib/jni

install/csladspa::
	mkdir $(CURDIR)/debian/tmp/usr/lib/ladspa
	mv $(CURDIR)/debian/tmp/usr/lib/csound/*/csladspa.so \
		$(CURDIR)/debian/tmp/usr/lib/ladspa/csladspa.so

install/libcsound64-doc::
	rm -f doc/csound/html/*.md5 doc/csound/html/*.map doc/csound/html/*.dot

# Don't ship any executable examples, they don't need to be
# Currently only arch packages carry examples
common-binary-post-install-arch::
	find debian/*/usr/share/doc/*/examples -type f -executable -print0 \
		| xargs -0 chmod -v a-x

common-binary-post-install-indep::
	dh_linktree

# Make sure that all files installed is also packaged
#  * ignore debhelper-installed files (we trust dh_install*)
#  * ignore python files (too tricky to track pycentral juggling)
binary: fail-missing
fail-missing: binary-arch binary-indep list-missing
	cat debian/cdbs-package-list | sort | uniq | \
		grep -v 'DEBIAN' | \
		grep -v '/$(PYLIBPATH)' | \
		grep -v '/usr/share/doc' | \
		grep -v '/usr/share/lintian/overrides' | \
		grep -v '/usr/share/menu' | \
		grep -v '/usr/share/pyshared' | \
		grep -v '/usr/lib/pyshared' \
		> debian/cdbs-reduced-package-list
	cat debian/cdbs-install-list | sort | uniq | \
		grep -v '/$(PYLIBPATH)' | \

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3

opts=uversionmangle=s/\.0$//,dversionmangle=s/(\.0)?\~dfsg[0-9]?$// \
	http://sf.net/csound/Csound([0-9\.]+)\.tar\.gz
